/*
 * CRCPP.hpp
 *
 *  Created on: Jan 19, 2018
 *      Author: steve.letsom
 */

#ifndef CRCPP_HPP_
#define CRCPP_HPP_



class CRRPTR
{


	string  crURL;
	int32_t crPort;
	bool crReportingEnabled;
	string crReportingURL;
	int crReportingPort;
	int crReportingMode;
	int crReportingInterval;
	int minRSSI = -110;
	int minRSSI4G = -120;
	int pingInterval = 120;
	string pingURL = "www.google.com";
	string altPingURL = "www.bing.com";
	int pingRetries = 5;
	int pingRetryInterval = 5;


	string reportBuffer;
	string IMEI;
	string firmware;
	string carrier;
	string mFirmware;
	string v4IPAddress;
	string timeStamp;
	le_mrc_NetRegState_t  regState;
	le_mrc_Rat_t  rat;
	string iccid;
   uint32_t              signalQuality;
   int32_t rxLevel = 0;
	uint32_t er = 0;
	int32_t ecio = 0;
	int32_t rscp = 0;
	int32_t sinr = 0;
	int32_t rsrq = 0;
	int32_t rsrp = 0;
	int32_t snr = 0;
	int32_t io = 0;


public:
	void Start(void);
	CRRPTR();
	string GetConnectSettings(void);


	~CRRPTR(){}

private:
	void ReadCRValues(void);
	void GetCarrier(void);
	void GetIMEI(void);
	void BuildCRReportString(void);
	void SendData(char * url, int portno);
	void CRReport(void);
	string GetSQLFormatDateTime(void);
	void GetSignalMetrics(void);
	void GetSignalStateAndQuality(void);
	void DoSignalStuff(Json::Value &root);


	//static void CRTimerHandler(le_timer_Ref_t timerRef);
	//void DeleteTimerAndFreePtr(le_timer_Ref_t t);
	//static void* TimerThread( void* contextPtr );


	//COMPONENT_INIT;

};



#endif /* CRCPP_HPP_ */
